AppTitle "GE5toSC4 Converter"
;
; -----------------------------------------------------------------------------
; Event constants...
; -----------------------------------------------------------------------------

Const EVENT_None		= $0		; No event (eg. a WaitEvent timeout)
Const EVENT_KeyDown		= $101		; Key pressed
Const EVENT_KeyUp		= $102		; Key released
Const EVENT_ASCII		= $103		; ASCII key pressed
Const EVENT_MouseDown	= $201		; Mouse button pressed
Const EVENT_MouseUp		= $202		; Mouse button released
Const EVENT_MouseMove	= $203		; Mouse moved
Const EVENT_Gadget		= $401		; Gadget clicked
Const EVENT_Move		= $801		; Window moved
Const EVENT_Size		= $802		; Window resized
Const EVENT_Close		= $803		; Window closed
Const EVENT_Front		= $804		; Window brought to front
Const EVENT_Menu		= $1001		; Menu item selected
Const EVENT_LostFocus	= $2001		; App lost focus
Const EVENT_GotFocus	= $2002		; App got focus
Const EVENT_Timer		= $4001		; Timer event occurred
;
Dim Palette(15,3)								
Dim MSXPalette(15,2)								
Dim msximg (256,212)
Dim tgp(256,8)
Dim tc(256,8)						
;
Global x,y
Global nberr=0
Global img= CreateImage(512,424,1) 		; cration d'un buffer de 256*212
Global errmsg$ = ""
;
Global window=CreateWindow("GE5toSC4",40,40,400,400,0,13)
mainmenu = CreateMenu ("&Files", 0, WindowMenu (window))
CreateMenu "&Load", 1, mainmenu
CreateMenu "&Save", 2, mainmenu
CreateMenu "", 3, mainmenu
CreateMenu "E&xit", 4, mainmenu
UpdateWindowMenu window;

Global canvas = CreateCanvas (0, 0, ClientWidth (window), ClientHeight (window), window)
Global SFile$ = ""
nberr=-1

While Not KeyHit(1)
	e = WaitEvent (1) ; The 'wait' value comes from above section...
	Select e
	Case EVENT_Close
 		 End
	Case EVENT_Menu	
 		 item = EventData ()
		 Select item
				Case 1
					sFile$ = RequestFile("Select GE5 File to convert","ge5,sc5",False)
					If sFile$<>"" Then
						Read_ge5(sfile$)
						ConvertToSc4()
					EndIf
				Case 2
					If nberr<0 Then Notify "Select GE5 file first."
					If nberr>0 Then Notify "Conversion error, file can't be saved."
					If nberr=0 Then 
						sFile$ = RequestFile("Save sc4 file","sc4",True)
						If sfile$<>"" Then saveVSC(sfile$)					
					EndIf
				Case 4
					If Confirm ("Are you sure you want to quit?") Then 	End
				End Select			
		End Select
	SetBuffer CanvasBuffer (canvas)		
	Refresh_Screen()
Wend 


;
; Refresh the screen
;
Function Refresh_Screen()
	Color 0,0,0
	Cls
	DrawBlock img,0,0
	Color 255,255,255
    If nberr>0 Then 
		Color 255,0,0
		Text 20,220,"Faulty blocks:"+nberr
	EndIf
    If nberr=0 Then 
		Color 255,255,255
		Text 20,220,"Conversion completed."		
		Text 20,240,"Palette data :   32 bytes"
		Text 20,250,"SC4 GFX data : 2048 bytes"
		Text 20,260,"Color data   : 2048 bytes"
		Text 20,270,"               ----------"
		Text 20,280,"TOTAL          4128 bytes"		
	EndIf
	VWait
	FlipCanvas canvas
End Function

;
; Read .GE5 file
;
Function Read_GE5(filename$)
file = OpenFile(filename$) 				
	SeekFile( file, 7 + 30336) 			
	For c = 0 To 15
		Byte_RB = ReadByte(file)		
		Byte_G=ReadByte(file)			
		msxpalette(c,0)=Byte_RB
		msxpalette(c,1)=Byte_G
		Palette (c,0)= (Byte_RB And 240)*2	
		Palette (c,1)= (Byte_G And 15)*32	
		Palette (c,2)= (Byte_RB And 15)*32	
	Next
	CloseFile(file)							
file = OpenFile (filename$)
;skip header
SeekFile(file,7)
SetBuffer ImageBuffer(img,0) 		
For y=0 To 63					; only need to read the 64 first lines for conversion
    For x=0 To 127
	    pixels = ReadByte(file)
	    colora = (pixels And 240)/16
	    colorb = (pixels And 15)
		msximg(x*2,y)     = Colora
		msximg((x*2)+1,y) = colorb
	    Color palette(colora,0),palette(colora,1),palette(colora,2)
	    Plot x*2,Y
	    Color palette(colorb,0),palette(colorb,1),palette(colorb,2)
	    Plot (x*2)+1,y
    Next
Next
End Function

Function ConvertToSC4()
nberr=0
SetBuffer ImageBuffer(img,0) 
Color 255,0,0
For row = 0 To 7
	For column = 0 To 31
		faulty=0
		For y=0 To 7
			nbcol=1
			c1=msximg((column*8),(row*8)+y)
			c2=-1
			TGPByte = 0
			For x = 0 To 7
				p = msximg((column*8)+x,(row*8)+y)
				If (p<>c1) Then
					If (c2=-1) Or (c2=p) Then 
						c2=P
					Else
						Rect column*8,row*8,8,8,0
						faulty=1
					EndIf
				EndIf
				If (p=c1) Then TGPByte = (TGPByte Or (2^(7-x)))
			Next
			If c2=-1 Then c2=0
			tgp((row*32)+column,y)=tgpbyte
			tc((row*32)+column,y)=(c1*16)+c2
		Next
		If faulty=1 Then nberr = nberr+1
	Next
Next
End Function
;
; Write sprite data
;
Function SaveVSC(filename$)
; Write tgs & tcs
VSCfile    = WriteFile(filename$) 	
For i = 0 To 15
	WriteByte(VSCfile,msxpalette(i,0))
	WriteByte(VSCfile,msxpalette(i,1))
Next
For i = 0 To 255
	For y = 0 To 7
		WriteByte(VSCfile,tgp(i,y))
	Next
Next
For i = 0 To 255
	For y = 0 To 7
		WriteByte(VSCfile,tc(i,y))
	Next
Next
CloseFile(VSCfile)
End Function